import json
import base64
import cv2
from Crypto.Cipher import AES
from flask import Flask
from concurrent.futures import ThreadPoolExecutor

key = None
message_set = set()
undecrypted_messages = []
messages = [['', '', '', '', '', ''],
            ['', '', '', '', '', ''],
            ['', '', '', '', '', '']]
counter = [0, 0, 0, 0, 0, 0]


def decrypt(text):
    cryptos = AES.new(key, AES.MODE_CBC, b'RoboMaster2019NB')
    plain_text = cryptos.decrypt(base64.b64decode(text)).decode()
    return plain_text.rstrip('\x00')


def process(message):
    plain_text = decrypt(message)
    number = int(plain_text[0])
    messages[counter[number]][number] = plain_text[2:]
    counter[number] += 1


def main():
    global key
    cap = cv2.VideoCapture(0)
    detector = cv2.QRCodeDetector()
    while True:
        _, frame = cap.read()
        retval, points, straight = detector.detectAndDecode(frame)
        if retval:
            print(retval)
            if retval[0:3] == 'key':
                if key is None:
                    key = retval[4:]
                    for message in undecrypted_messages:
                        process(message)
            elif key is not None:
                if retval not in message_set:
                    message_set.add(retval)
                    process(retval)
            else:
                if retval not in message_set:
                    message_set.add(retval)
                    undecrypted_messages.append(retval)
            print(messages)


executor = ThreadPoolExecutor(max_workers=1)

executor.submit(main)

app = Flask(__name__)


@app.route('/')
def get_messages():
    return json.dumps(messages, ensure_ascii=False)


app.run()
